/**************************
*** Particel Header-File ***
 **************************/

#ifndef PARTICLESYS_HEADER
#define PARTICLESYS_HEADER

//#pragma once
#include <sdl.h>
#include <vector>
using namespace std;

// Klasse fr den Particel //
/////////////////////////////
class CParticel
{
public:
	CParticel();
	CParticel(short x, short y, short farbe);
	virtual ~CParticel();
	void tick();
	// statiche variablen
	static Uint32** feld;
	static Uint32** farben;
	static bool const_geschw,zuf_richtwechsel;
	static short feldbreite,feldhoehe,richtungen,schweifl;

private:
	short dx,dy;
	struct strSchweif
	{
		short x;
		short y;
	};
	strSchweif* schweif;
	short farbe;	// der Index fr die Farbe
	short count;	// zhler fr die zufllige richtungsnderung

	// statiche Funktionen
	static void zufall(short &dx, short &dy);
	static void tick_alle(short &dx, short &dy,short &count, short &farbe, strSchweif* schweif);
};

// Klasse fr das System um den Particel //
///////////////////////////////////////////
class CParticelSys
{
public:
	CParticelSys(int feldbreite,int feldhoehe,short schweifl, short richtungen=2, short farbtiefe=0, bool fullscreen=false);
	virtual ~CParticelSys();

	void zeichnen();

	void const_geschw(bool wert){CParticel::const_geschw=wert;};
	void zuf_richtwechsel(bool wert){CParticel::zuf_richtwechsel=wert;};
	void max_geschw_par(short geschw){CParticel::richtungen=geschw;};

	void neue_particel(short x,short y, int anzahl=1, short farbe=0);
	void alle_par_weg();

private:
	vector<CParticel*> par;

	Uint32 **feld;
	short feldbreite,feldhoehe;
	
	SDL_Surface *pS;
	void SetPixel(short x, short y);
	
};


#endif